///////////////////////////////////////////////////
//Beispiel Kapitel Turtlegrafik
//Schneeflocke ohne LSystem
//////////////////////////////////////////////////
// Zustand der Turtle
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=750;
int h=750;

float laenge = 512;
float delta = 60;
int tiefe = 1;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() 
{
}

///////////////////////////////////////////////////////////

void draw() {
  background(255);
  translate(30,height-30); 
  strokeWeight(2);
  setColor(color(255,0,0));
  penDown();
  laenge = (0.9*width)/pow(3, tiefe);
  maleSchneeflocke(tiefe);
}

///////////////////////////////////////////////////////////

void keyPressed() {
  if (key == '+') {
    tiefe = min(10, tiefe+1);
    redraw();
  }
  if (key == '-') {
    tiefe = max(1, tiefe-1);
    redraw();
  }
}

///////////////////////////////////////////////////////////

void maleSchneeflocke(int gen) {
  if (gen==0) move(laenge); 
  else {
    maleSchneeflocke(gen-1);
    turn(delta);
    maleSchneeflocke(gen-1);
    turn(-delta);
    turn(-delta);
    maleSchneeflocke(gen-1);
    turn(delta);
    maleSchneeflocke(gen-1);
  }
}

///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) line(0,0,len,0);
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }
